var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule, Injector } from '@angular/core';
import { FirebaseAuth } from './firebase-auth.service';
import { FirebaseDatabase } from './firebase-database.service';
import { FirebaseApp } from './firebase-app.service';
/** @internal */
var lazyInvocation = true;
export function invokeLazy() {
    return lazyInvocation;
}
function setLazyInvocation(lazy) {
    lazyInvocation = lazy;
}
var FirebaseModule = FirebaseModule_1 = (function () {
    function FirebaseModule() {
    }
    FirebaseModule.forRoot = function (config, lazyInvocation) {
        if (lazyInvocation === void 0) { lazyInvocation = true; }
        this.validateConfig(config);
        setLazyInvocation(lazyInvocation);
        return {
            ngModule: FirebaseModule_1,
            providers: this.getProviders(config)
        };
    };
    FirebaseModule.validateConfig = function (config) {
        var defaultApps = config.filter(function (config) { return !config.token; });
        if (defaultApps.length > 1) {
            throw new Error('There can only be one default Firebase App');
        }
    };
    FirebaseModule.getProviders = function (config) {
        var defaultApp = config.filter(function (config) { return !config.token; })[0];
        var additionalApps = config.filter(function (config) { return !!config.token; });
        return [
            {
                provide: FirebaseApp,
                useFactory: function (injector) { return new FirebaseApp(defaultApp, injector); },
                deps: [Injector]
            },
            {
                provide: FirebaseAuth,
                useFactory: function (firebaseApp) { return firebaseApp.auth(); },
                deps: [FirebaseApp]
            },
            {
                provide: FirebaseDatabase,
                useFactory: function (firebaseApp) { return firebaseApp.database(); },
                deps: [FirebaseApp]
            }
        ].concat(additionalApps.map(function (config) { return ({
            provide: config.token,
            useFactory: function (injector) { return new FirebaseApp(config, injector); },
            deps: [Injector]
        }); }));
    };
    return FirebaseModule;
}());
FirebaseModule = FirebaseModule_1 = __decorate([
    NgModule({})
], FirebaseModule);
export { FirebaseModule };
var FirebaseModule_1;
//# sourceMappingURL=firebase.module.js.map