import { Observable } from 'rxjs';
import 'zone.js';
import { invokeLazy } from './firebase.module';
export function wrapExternalPromise(promise) {
    return new Promise(function (resolve, reject) {
        promise
            .then(function (res) { return resolve(res); })
            .catch(function (err) { return reject(err); });
    });
}
export function wrapPromise(promiseFact) {
    if (invokeLazy()) {
        return new Observable(function (sub) {
            Observable.fromPromise(wrapExternalPromise(promiseFact()))
                .subscribe(sub);
        });
    }
    return Observable.fromPromise(wrapExternalPromise(promiseFact()));
}
//# sourceMappingURL=utils.js.map